<script setup lang="ts">
import { computed, onMounted } from 'vue'
import { nextTick, ref } from 'vue'
import type { VForm } from 'vuetify/components'
type status = 'Paid' | 'Unpaid'
type Salary = {
  id: number
  name: string
  role: string
  bankAccount: string
  salary: number
  increases: number
  decreasess: number
  netSalary: number
  payDate: Date
  status: status
}

const salarys = ref<Salary[]>([])
const headers = [
  {
    title: 'ID',
    key: 'id',
    value: 'id'
  },
  {
    title: 'Full Name',
    key: 'name',
    value: 'name'
  },
  {
    title: 'Bank Account',
    key: 'bankAccount',
    value: 'bankAccount'
  },
  {
    title: 'Salary',
    key: 'salary',
    value: (item: Salary) => item.salary.toFixed(2)
  },
  {
    title: 'Increases',
    key: 'increases',
    value: (item: Salary) => item.increases.toFixed(2)
  },
  {
    title: 'Deducted',
    key: 'decreasess',
    value: (item: Salary) => item.decreasess.toFixed(2)
  },
  {
    title: 'Net.Salary',
    key: 'netSalary',
    value: (item: Salary) => item.netSalary.toFixed(2)
  },
  {
    title: 'Status',
    key: 'status',
    value: 'status'
  },
  { title: 'Actions', key: 'actions', sortable: false }
]
const form = ref(false)
const refForm = ref<VForm | null>(null)
const dialog = ref(false)
const receipt = ref(false)
const dialogDelete = ref(false)
const loading = ref(false)
const search = ref('')
const alreadyDialog = ref(false)
let myDate = new Date()
const initialSalary: Salary = {
  id: -1,
  name: '',
  role: '',
  bankAccount: '',
  salary: 0,
  increases: 0,
  decreasess: 0,
  netSalary: 0,
  payDate: myDate,
  status: 'Unpaid'
}
let editedIndex = -1
let lastId = 14
const editedSalary = ref<Salary>(JSON.parse(JSON.stringify(initialSalary)))
function closeDelete() {
  dialogDelete.value = false
  nextTick(() => {
    editedSalary.value = Object.assign({}, initialSalary)
    editedIndex = -1
  })
}
function deleteItemConfirm() {
  //Delete item from list
  salarys.value.splice(editedIndex, 1)
  closeDelete()
}
function editItem(item: Salary) {
  editedIndex = salarys.value.indexOf(item)
  editedSalary.value = Object.assign({}, item)
  dialog.value = true
}
function deleteItem(item: Salary) {
  editedIndex = salarys.value.findIndex((s) => s.id === item.id)
  editedSalary.value = Object.assign({}, item)
  dialogDelete.value = true
}
function receiptSalary(item: Salary) {
  editedIndex = salarys.value.indexOf(item)
  editedSalary.value = Object.assign({}, item)
  if (editedSalary.value.status == 'Unpaid') {
    receipt.value = false
  } else {
    editedIndex = salarys.value.indexOf(item)
    editedSalary.value = Object.assign({}, item)
    receipt.value = true
  }

}
const payDialog = ref(false)

function confirmPay() {
  payDialog.value = true
  const index = editedSalary.value.id - 1
  if (editedSalary.value.status === 'Unpaid') {
    editedSalary.value.status = 'Paid'
    salarys.value[index] = { ...editedSalary.value }
    console.log(salarys.value)
  }
  nextTick(() => {
    editedSalary.value = Object.assign({}, initialSalary)
  })
  console.log(salarys.value)
  closePayDialog()
}

function openPayDialog(item: Salary) {
  editedIndex = salarys.value.indexOf(item)
  editedSalary.value = Object.assign({}, item)
  if (editedSalary.value.status === 'Paid') {
    alreadyDialog.value = true
  } else {
    payDialog.value = true
    console.log(item);
  }
}

function closePayDialog() {
  payDialog.value = false
  nextTick(() => {
    editedSalary.value = Object.assign({}, initialSalary)
  })
}

function closeAlreadyDialog() {
  alreadyDialog.value = false
  nextTick(() => {
    editedSalary.value = Object.assign({}, initialSalary)
  })
}
function onSubmit() { }
function initialize() {
  salarys.value = [
    {
      id: 1,
      name: 'Tanakit Wongviroj',
      role: 'Manager',
      bankAccount: '324-1-12345-9',
      salary: 20000,
      increases: 1000,
      decreasess: 450,
      netSalary: 20550,
      payDate: new Date('2024-01-01'),
      status: 'Paid'
    },
    {
      id: 2,
      name: 'Sivat Ratanawong',
      role: 'Barista',
      bankAccount: '024-0-12545-9',
      salary: 15000,
      increases: 900,
      decreasess: 100,
      netSalary: 14200,
      payDate: new Date('2024-01-02'),
      status: 'Paid'
    },
    {
      id: 3,
      name: 'Kornnisa Thongiam',
      role: 'Manager',
      bankAccount: '332-1-12315-0',
      salary: 25000,
      increases: 2000,
      decreasess: 700,
      netSalary: 26300,
      payDate: new Date(),
      status: 'Unpaid'
    },
    {
      id: 4,
      name: 'Supasita Pochawat',
      role: 'Barista',
      bankAccount: '054-8-02345-1',
      salary: 12000,
      increases: 500,
      decreasess: 50,
      netSalary: 12450,
      payDate: new Date('2024-01-04'),
      status: 'Paid'
    },
    {
      id: 5,
      name: 'Chanapa Pumthong',
      role: 'Barista',
      bankAccount: '021-9-12245-8',
      salary: 12000,
      increases: 1000,
      decreasess: 200,
      netSalary: 12800,
      payDate: new Date(),
      status: 'Unpaid'
    },
    {
      id: 6,
      name: 'Kwantip Siriworapat',
      role: 'Barista',
      bankAccount: '021-9-12245-8',
      salary: 18000,
      increases: 1000,
      decreasess: 100,
      netSalary: 18100,
      payDate: new Date(),
      status: 'Unpaid'
    },
    {
      id: 7,
      name: 'Pimpisut Kaokritsadee',
      role: 'Barista',
      bankAccount: '021-9-12245-8',
      salary: 12000,
      increases: 1000,
      decreasess: 200,
      netSalary: 12800,
      payDate: new Date('2023-12-30'),
      status: 'Paid'
    },
    {
      id: 8,
      name: 'Tanapa Charoenjit',
      role: 'Barista',
      bankAccount: '021-9-12245-8',
      salary: 12000,
      increases: 1000,
      decreasess: 200,
      netSalary: 12800,
      payDate: new Date('2023-12-31'),
      status: 'Paid'
    },
    {
      id: 9,
      name: 'Yanisa Wongsawat',
      role: 'Barista',
      bankAccount: '021-9-12245-8',
      salary: 12000,
      increases: 1000,
      decreasess: 200,
      netSalary: 12800,
      payDate: new Date(),
      status: 'Unpaid'
    },
    {
      id: 10,
      name: 'Aphiwit Pluemchit',
      role: 'Barista',
      bankAccount: '021-9-12245-8',
      salary: 12000,
      increases: 1000,
      decreasess: 200,
      netSalary: 12800,
      payDate: new Date(),
      status: 'Unpaid'
    },
    {
      id: 11,
      name: 'Chanonthananan Narongsil',
      role: 'Barista',
      bankAccount: '021-9-12245-8',
      salary: 12000,
      increases: 1000,
      decreasess: 200,
      netSalary: 12800,
      payDate: new Date(),
      status: 'Unpaid'
    },
    {
      id: 12,
      name: 'Phuttiphong Khantasen',
      role: 'Barista',
      bankAccount: '054-5-059-737',
      salary: 15000,
      increases: 1000,
      decreasess: 200,
      netSalary: 14000,
      payDate: new Date(),
      status: 'Unpaid'
    },
    {
      id: 13,
      name: 'Poomrapee Sadsamai',
      role: 'Barista',
      bankAccount: '076-3-91871-4',
      salary: 10000,
      increases: 100,
      decreasess: 50,
      netSalary: 10050,
      payDate: new Date('2023-12-31'),
      status: 'Paid'
    }
  ]
}
const page = ref(1)
const itemsPerPage = ref<any>(6)
const pageCount = computed(() => {
  return Math.ceil(salarys.value.length / itemsPerPage.value)
})
onMounted(() => {
  initialize()
})
function closeDialog() {
  dialog.value = false
  nextTick(() => {
    editedSalary.value = Object.assign({}, initialSalary)
  })
}
async function save() {
  const { valid } = await refForm.value!.validate()

  if (!valid) return

  editedSalary.value.id = lastId++
  editedSalary.value.payDate = myDate
  const formattedNumber = `${editedSalary.value.bankAccount.slice(0, 3)}-${editedSalary.value.bankAccount.slice(3, 4)}-${editedSalary.value.bankAccount.slice(4, 9)}-${editedSalary.value.bankAccount.slice(9)}`;
  editedSalary.value.bankAccount = formattedNumber
  salarys.value.push(editedSalary.value)
  calNetSalary()
  closeDialog()
}
function getEmployeeNames() {
  return salarys.value.map((employee) => employee.name)
}
function calNetSalary() {
  const netSalary =
    editedSalary.value.salary + editedSalary.value.increases - editedSalary.value.decreasess
  editedSalary.value.netSalary = netSalary
}
function calTotalIncome() {
  return editedSalary.value.salary + editedSalary.value.increases
}
function closeReceipt() {
  receipt.value = false
  nextTick(() => {
    editedSalary.value = Object.assign({}, initialSalary)
  })
}

//for search
const formattedSalarys = computed(() => salarys.value.map((Salary) => ({ ...Salary })))

const filteredSalarys = computed(() => {
  const searchLower = search.value.toLowerCase()
  return formattedSalarys.value.filter((Salary: Salary) =>
    Salary.name.toLowerCase().includes(searchLower)
  )
})


</script>

<template>
  <div style="width: 95%">
    <!--dialog of new salary-->
    <v-dialog v-model="dialog" persistent width="1024">
      <template v-slot:activator="{ props }">
        <div>

          <div style="margin-left: 20px">
            <h1>SALARY</h1>
          </div>
          <v-btn class="ma-2" style="background-color: rgb(139, 82, 38)" v-bind="props">
            <v-icon icon="mdi-cash-plus" size="25px" class="mr-2"></v-icon>
            <div style="text-align: left">New Salary</div>
          </v-btn>

          <!--title-->
          <v-card-title class="d-flex align-center pe-2">
            <v-icon icon="mdi-account-cash"></v-icon> &nbsp; Salary
            <v-spacer></v-spacer>

            <!-- search -->
            <v-text-field v-model="search" prepend-inner-icon="mdi-magnify" density="compact" label="Search" single-line
              flat hide-details variant="solo-filled"></v-text-field>
          </v-card-title>

          <!--table-->
          <v-data-table v-model:page="page" :headers="(headers as any)" :items="filteredSalarys"
            :items-per-page="itemsPerPage">
            <template v-slot:bottom>
              <div class="text-center pt-2">
                <v-pagination v-model="page" :length="pageCount"></v-pagination>
              </div>
            </template>

            <template v-slot:[`item.payDate`]="{ value }">
              <!--PayDate format in Table-->
              {{ value.toLocaleDateString('en-GB') }}
            </template>

            <template v-slot:[`item.status`]="{ item }">
              <div class="text-start">
                <v-chip :color="item.status === 'Paid' ? 'green' : 'red'" class="text-uppercase" label size="small">{{
                  item.status === 'Paid' ? 'Paid' : 'Unpaid' }}
                </v-chip>
              </div>
            </template>


            <template v-slot:[`item.actions`]="{ item }">
              <v-icon size="small" @click="deleteItem(item)"> mdi-delete </v-icon>
              <v-icon size="small" @click="openPayDialog(item)">mdi-cash </v-icon>
              <v-icon size="small" @click="receiptSalary(item)"> mdi-printer </v-icon>
            </template>
          </v-data-table>
        </div>



        <!--Bill-->
        <v-dialog v-model="receipt" persistent>
          <v-card :width="700" class="pa-6 mx-auto">
            <v-container>
              <v-row no-gutters>
                <v-col><v-img :width="85" src="./img/logo/logo1.jpg" class="image-position"></v-img></v-col>
                <v-spacer></v-spacer>
                <v-spacer></v-spacer>
                <v-spacer></v-spacer>
                <v-spacer></v-spacer>
                <v-spacer></v-spacer>
                <v-col cols="12" sm="12" md="4"></v-col>
                <v-col style="text-align: left" class="col" cols="12" sm="12" md="4">
                  Employee ID: {{ editedSalary.id }} <br />
                  Employee Name: {{ editedSalary.name }} <br />
                  <!-- Position: {{ editedSalary.role }} <br> -->
                  Payment Date: {{ editedSalary.payDate.toLocaleDateString('en-GB') }}
                </v-col>
                <v-col></v-col>
              </v-row>
              <v-row no-gutters>----------------------------------------------------------------------------------</v-row>
              <v-row no-gutters>
                <v-col>Income</v-col>
                <v-col>Amount</v-col>
                <v-col>Deducted</v-col>
                <v-col>Amount</v-col>
              </v-row>
              <v-row no-gutters>----------------------------------------------------------------------------------</v-row>
              <v-row no-gutters>
                <v-col style="font-size: small">Salary</v-col>
                <v-col class="emp" style="font-size: small">{{ editedSalary.salary.toFixed(2) }} THB</v-col>
                <v-col style="font-size: small">Deducted</v-col>
                <v-col class="emp" style="font-size: small">{{ editedSalary.decreasess.toFixed(2) }} THB</v-col>
              </v-row>
              <v-row no-gutters>
                <v-col style="font-size: small">Income</v-col>
                <v-col class="emp" style="font-size: small">{{ editedSalary.increases.toFixed(2) }} THB</v-col>
                <v-col></v-col>
                <v-col></v-col>
              </v-row>
              <v-row no-gutters>
                <v-col style="font-size: small">Total Income :</v-col>
                <v-col class="emp" style="font-size: small">{{ calTotalIncome() }} THB</v-col>
                <v-col style="font-size: small">Total Deducted :</v-col>
                <v-col class="emp" style="font-size: small">{{ editedSalary.decreasess.toFixed(2) }} THB</v-col>
              </v-row>
              <v-row no-gutters>----------------------------------------------------------------------------------</v-row>
              <v-row no-gutters>
                <v-col></v-col>
                <v-col></v-col>
                <v-col>Total Receive :</v-col>
                <v-col class="emp" style="font-size: small">{{ editedSalary.netSalary.toFixed(2) }} THB</v-col>
              </v-row>
            </v-container>


            <!--Dialog printSlip-->
            <v-card-actions>
              <v-spacer></v-spacer>
              <v-btn color="red" variant="flat" style="width: 150px; height: 50px" class="mb-3" @click="closeReceipt()">
                Cancel
              </v-btn>
              <v-btn color="success" variant="flat" style="width: 150px; height: 50px" class="mb-3"
                @click="closeReceipt()">
                Print
              </v-btn>
            </v-card-actions>

          </v-card>
        </v-dialog>

        <!--Delete Dialog-->
        <v-dialog v-model="dialogDelete" max-width="500px" persistent>
          <v-card>
            <v-card-title class="div" style="text-align: center" :class="['ma - 10', 'pt-6']">you want to delete
              this info? 🗑️</v-card-title>
            <v-card-actions>
              <v-spacer></v-spacer>
              <v-btn color="red" variant="flat" style="width: 150px; height: 50px" class="mb-3"
                @click="closeDelete">Cancel</v-btn>
              <v-btn color="success" variant="flat" style="width: 150px; height: 50px" class="mb-3"
                @click="deleteItemConfirm">Delete</v-btn>
              <v-spacer></v-spacer>
            </v-card-actions>
          </v-card>
        </v-dialog>

        <!--Pay Dialog-->
        <v-dialog v-model="payDialog" max-width="500px" persistent>
          <v-card>
            <v-card-title class="div" style="text-align: center" :class="['ma - 10', 'pt-6']">you want to pay
              this info? 🗑️</v-card-title>
            <v-card-actions>
              <v-spacer></v-spacer>
              <v-btn color="red" variant="flat" style="width: 150px; height: 50px" @click="closePayDialog">Cancel</v-btn>
              <v-btn color="success" variant="flat" style="width: 150px; height: 50px" @click="confirmPay">Pay</v-btn>
              <v-spacer></v-spacer>
            </v-card-actions>
          </v-card>
        </v-dialog>

        <!--Already Pay-->
        <v-dialog v-model="alreadyDialog" max-width="500px" persistent>
          <v-card height="140px">
            <v-card-title class="div" style="text-align: center" :class="['ma - 10', 'pt-6']">
              <v-icon>mdi-check-circle-outline</v-icon> This salary has been paid.
            </v-card-title>
            <v-card-actions>
              <v-spacer></v-spacer>
              <v-btn color="success" variant="flat" style="width: 150px; height: 50px"
                @click="closeAlreadyDialog">OK</v-btn>
              <v-spacer></v-spacer>
            </v-card-actions>
          </v-card>
        </v-dialog>
      </template>

      <!--New Salary Dialog-->
      <v-card title="New Salary" class="pt-6" style="text-align: center">
        <v-card-title color="blue"> </v-card-title>
        <v-card-text>
          <v-form ref="refForm" v-model="form" @submit.prevent="onSubmit">
            <v-container>
              <v-row>
                <v-col cols="12" sm="12" md="4">
                  <!-- <v-list-subheader>Profile</v-list-subheader> -->
                  <v-autocomplete clearable :items="getEmployeeNames()" label="Name" variant="outlined"
                    v-model="editedSalary.name">
                  </v-autocomplete>
                </v-col>
                <v-col cols="12" sm="12" md="4">
                  <v-text-field type="number" pattern="[0-9]*" min="100" max="50000" v-model.number="editedSalary.salary"
                    :readonly="loading" suffix="THB" :rules="[
                      (v) => !!v || 'Field is required',
                      (v) => v >= 0 || 'Must be a non-negative number'
                    ]" class="mb-2" clearable label="Salary" variant="outlined"></v-text-field>
                </v-col>
                <v-col cols="12" sm="12" md="4">
                  <v-text-field type="number" pattern="[0-9]*" min="100" max="10000"
                    v-model.number="editedSalary.increases" :readonly="loading" suffix="THB" :rules="[
                      (v) => !!v || 'Field is required',
                      (v) => v >= 0 || 'Must be a non-negative number'
                    ]" class="mb-2" clearable label="Increase" variant="outlined"></v-text-field>
                </v-col>
                <v-col cols="12" sm="12" md="4">
                  <v-text-field type="number" pattern="[0-9]*" min="100" max="10000"
                    v-model.number="editedSalary.decreasess" :readonly="loading" suffix="THB" :rules="[
                      (v) => !!v || 'Field is required',
                      (v) => v >= 0 || 'Must be a non-negative number'
                    ]" class="mb-2" clearable label="Deducted" variant="outlined"></v-text-field>
                </v-col>
                <v-col cols="12" sm="12" md="4">
                  <v-text-field v-model="editedSalary.bankAccount" :readonly="loading" :rules="[
                    (v) => !!v || 'Field is required',
                    (v) => (v && v.length === 10) || 'Account number must be 10 digits',
                    (v) => /^\d+$/.test(v) || 'Account number must contain only digits'
                  ]" clearable label="Bank Account" variant="outlined"></v-text-field>
                </v-col>
                <v-col cols="12" sm="12" md="4">
                  <v-text-field v-model="myDate" :readonly="true" label="Payment Date" variant="outlined"></v-text-field>
                </v-col>
              </v-row>
            </v-container>
          </v-form>
        </v-card-text>
        <v-card-actions>
          <v-spacer></v-spacer>
          <v-btn style="width: 200px; height: 60px" variant="flat" color="red" @click="closeDialog()">
            Close
          </v-btn>
          <v-btn style="width: 200px; height: 60px" variant="flat" color="success" @click="save()">
            Save
          </v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>
  </div>
</template>

<style scoped>
div {
  font-family: 'Kanit';
}

.v-btn {
  width: 235px;
  height: 90px;
  color: white;
  font-family: Verdana, sans-serif;
}
</style>
